diff --git a/fs/ext4/super.c b/fs/ext4/super.c
index 56baadec27e0..89955081c4fe 100644
--- a/fs/ext4/super.c
+++ b/fs/ext4/super.c
@@ -1723,101 +1723,94 @@ static const struct constant_table ext4_param_dax[] = {
  * separate for now.
  */
 static const struct fs_parameter_spec ext4_param_specs[] = {
-	fsparam_flag	("bsddf",		Opt_bsd_df),
-	fsparam_flag	("minixdf",		Opt_minix_df),
-	fsparam_flag	("grpid",		Opt_grpid),
-	fsparam_flag	("bsdgroups",		Opt_grpid),
-	fsparam_flag	("nogrpid",		Opt_nogrpid),
-	fsparam_flag	("sysvgroups",		Opt_nogrpid),
-	fsparam_gid	("resgid",		Opt_resgid),
-	fsparam_uid	("resuid",		Opt_resuid),
-	fsparam_u32	("sb",			Opt_sb),
-	fsparam_enum	("errors",		Opt_errors, ext4_param_errors),
-	fsparam_flag	("nouid32",		Opt_nouid32),
-	fsparam_flag	("debug",		Opt_debug),
-	fsparam_flag	("oldalloc",		Opt_removed),
-	fsparam_flag	("orlov",		Opt_removed),
-	fsparam_flag	("user_xattr",		Opt_user_xattr),
-	fsparam_flag	("acl",			Opt_acl),
-	fsparam_flag	("norecovery",		Opt_noload),
-	fsparam_flag	("noload",		Opt_noload),
-	fsparam_flag	("bh",			Opt_removed),
-	fsparam_flag	("nobh",		Opt_removed),
-	fsparam_u32	("commit",		Opt_commit),
-	fsparam_u32	("min_batch_time",	Opt_min_batch_time),
-	fsparam_u32	("max_batch_time",	Opt_max_batch_time),
-	fsparam_u32	("journal_dev",		Opt_journal_dev),
-	fsparam_bdev	("journal_path",	Opt_journal_path),
-	fsparam_flag	("journal_checksum",	Opt_journal_checksum),
-	fsparam_flag	("nojournal_checksum",	Opt_nojournal_checksum),
-	fsparam_flag	("journal_async_commit",Opt_journal_async_commit),
-	fsparam_flag	("abort",		Opt_abort),
-	fsparam_enum	("data",		Opt_data, ext4_param_data),
-	fsparam_enum	("data_err",		Opt_data_err,
+	fsparam_flag("bsddf",			Opt_bsd_df),
+	fsparam_flag("minixdf",			Opt_minix_df),
+	fsparam_flag("grpid",			Opt_grpid),
+	fsparam_flag("bsdgroups",		Opt_grpid),
+	fsparam_flag("nogrpid",			Opt_nogrpid),
+	fsparam_flag("sysvgroups",		Opt_nogrpid),
+	fsparam_gid("resgid",			Opt_resgid),
+	fsparam_uid("resuid",			Opt_resuid),
+	fsparam_u32("sb",			Opt_sb),
+	fsparam_enum("errors",			Opt_errors, ext4_param_errors),
+	fsparam_flag("nouid32",			Opt_nouid32),
+	fsparam_flag("debug",			Opt_debug),
+	fsparam_flag("oldalloc",		Opt_removed),
+	fsparam_flag("orlov",			Opt_removed),
+	fsparam_flag("user_xattr",		Opt_user_xattr),
+	fsparam_flag("acl",			Opt_acl),
+	fsparam_flag("norecovery",		Opt_noload),
+	fsparam_flag("noload",			Opt_noload),
+	fsparam_flag("bh",			Opt_removed),
+	fsparam_flag("nobh",			Opt_removed),
+	fsparam_u32("commit",			Opt_commit),
+	fsparam_u32("min_batch_time",		Opt_min_batch_time),
+	fsparam_u32("max_batch_time",		Opt_max_batch_time),
+	fsparam_u32("journal_dev",		Opt_journal_dev),
+	fsparam_bdev("journal_path",		Opt_journal_path),
+	fsparam_flag("journal_checksum",	Opt_journal_checksum),
+	fsparam_flag("nojournal_checksum",	Opt_nojournal_checksum),
+	fsparam_flag("journal_async_commit",	Opt_journal_async_commit),
+	fsparam_flag("abort",			Opt_abort),
+	fsparam_enum("data",			Opt_data, ext4_param_data),
+	fsparam_enum("data_err",		Opt_data_err,
 						ext4_param_data_err),
-	fsparam_string_empty
-			("usrjquota",		Opt_usrjquota),
-	fsparam_string_empty
-			("grpjquota",		Opt_grpjquota),
-	fsparam_enum	("jqfmt",		Opt_jqfmt, ext4_param_jqfmt),
-	fsparam_flag	("grpquota",		Opt_grpquota),
-	fsparam_flag	("quota",		Opt_quota),
-	fsparam_flag	("noquota",		Opt_noquota),
-	fsparam_flag	("usrquota",		Opt_usrquota),
-	fsparam_flag	("prjquota",		Opt_prjquota),
-	fsparam_flag	("barrier",		Opt_barrier),
-	fsparam_u32	("barrier",		Opt_barrier),
-	fsparam_flag	("nobarrier",		Opt_nobarrier),
-	fsparam_flag	("i_version",		Opt_removed),
-	fsparam_flag	("dax",			Opt_dax),
-	fsparam_enum	("dax",			Opt_dax_type, ext4_param_dax),
-	fsparam_u32	("stripe",		Opt_stripe),
-	fsparam_flag	("delalloc",		Opt_delalloc),
-	fsparam_flag	("nodelalloc",		Opt_nodelalloc),
-	fsparam_flag	("warn_on_error",	Opt_warn_on_error),
-	fsparam_flag	("nowarn_on_error",	Opt_nowarn_on_error),
-	fsparam_u32	("debug_want_extra_isize",
-						Opt_debug_want_extra_isize),
-	fsparam_flag	("mblk_io_submit",	Opt_removed),
-	fsparam_flag	("nomblk_io_submit",	Opt_removed),
-	fsparam_flag	("block_validity",	Opt_block_validity),
-	fsparam_flag	("noblock_validity",	Opt_noblock_validity),
-	fsparam_u32	("inode_readahead_blks",
-						Opt_inode_readahead_blks),
-	fsparam_u32	("journal_ioprio",	Opt_journal_ioprio),
-	fsparam_u32	("auto_da_alloc",	Opt_auto_da_alloc),
-	fsparam_flag	("auto_da_alloc",	Opt_auto_da_alloc),
-	fsparam_flag	("noauto_da_alloc",	Opt_noauto_da_alloc),
-	fsparam_flag	("dioread_nolock",	Opt_dioread_nolock),
-	fsparam_flag	("nodioread_nolock",	Opt_dioread_lock),
-	fsparam_flag	("dioread_lock",	Opt_dioread_lock),
-	fsparam_flag	("discard",		Opt_discard),
-	fsparam_flag	("nodiscard",		Opt_nodiscard),
-	fsparam_u32	("init_itable",		Opt_init_itable),
-	fsparam_flag	("init_itable",		Opt_init_itable),
-	fsparam_flag	("noinit_itable",	Opt_noinit_itable),
+	fsparam_string_empty("usrjquota",	Opt_usrjquota),
+	fsparam_string_empty("grpjquota",	Opt_grpjquota),
+	fsparam_enum("jqfmt",			Opt_jqfmt, ext4_param_jqfmt),
+	fsparam_flag("grpquota",		Opt_grpquota),
+	fsparam_flag("quota",			Opt_quota),
+	fsparam_flag("noquota",			Opt_noquota),
+	fsparam_flag("usrquota",		Opt_usrquota),
+	fsparam_flag("prjquota",		Opt_prjquota),
+	fsparam_flag("barrier",			Opt_barrier),
+	fsparam_u32("barrier",			Opt_barrier),
+	fsparam_flag("nobarrier",		Opt_nobarrier),
+	fsparam_flag("i_version",		Opt_removed),
+	fsparam_flag("dax",			Opt_dax),
+	fsparam_enum("dax",			Opt_dax_type, ext4_param_dax),
+	fsparam_u32("stripe",			Opt_stripe),
+	fsparam_flag("delalloc",		Opt_delalloc),
+	fsparam_flag("nodelalloc",		Opt_nodelalloc),
+	fsparam_flag("warn_on_error",		Opt_warn_on_error),
+	fsparam_flag("nowarn_on_error",		Opt_nowarn_on_error),
+	fsparam_u32("debug_want_extra_isize",	Opt_debug_want_extra_isize),
+	fsparam_flag("mblk_io_submit",		Opt_removed),
+	fsparam_flag("nomblk_io_submit",	Opt_removed),
+	fsparam_flag("block_validity",		Opt_block_validity),
+	fsparam_flag("noblock_validity",	Opt_noblock_validity),
+	fsparam_u32("inode_readahead_blks",	Opt_inode_readahead_blks),
+	fsparam_u32("journal_ioprio",		Opt_journal_ioprio),
+	fsparam_u32("auto_da_alloc",		Opt_auto_da_alloc),
+	fsparam_flag("auto_da_alloc",		Opt_auto_da_alloc),
+	fsparam_flag("noauto_da_alloc",		Opt_noauto_da_alloc),
+	fsparam_flag("dioread_nolock",		Opt_dioread_nolock),
+	fsparam_flag("nodioread_nolock",	Opt_dioread_lock),
+	fsparam_flag("dioread_lock",		Opt_dioread_lock),
+	fsparam_flag("discard",			Opt_discard),
+	fsparam_flag("nodiscard",		Opt_nodiscard),
+	fsparam_u32("init_itable",		Opt_init_itable),
+	fsparam_flag("init_itable",		Opt_init_itable),
+	fsparam_flag("noinit_itable",		Opt_noinit_itable),
 #ifdef CONFIG_EXT4_DEBUG
-	fsparam_flag	("fc_debug_force",	Opt_fc_debug_force),
-	fsparam_u32	("fc_debug_max_replay",	Opt_fc_debug_max_replay),
+	fsparam_flag("fc_debug_force",		Opt_fc_debug_force),
+	fsparam_u32("fc_debug_max_replay",	Opt_fc_debug_max_replay),
 #endif
-	fsparam_u32	("max_dir_size_kb",	Opt_max_dir_size_kb),
-	fsparam_flag	("test_dummy_encryption",
-						Opt_test_dummy_encryption),
-	fsparam_string	("test_dummy_encryption",
-						Opt_test_dummy_encryption),
-	fsparam_flag	("inlinecrypt",		Opt_inlinecrypt),
-	fsparam_flag	("nombcache",		Opt_nombcache),
-	fsparam_flag	("no_mbcache",		Opt_nombcache),	/* for backward compatibility */
-	fsparam_flag	("prefetch_block_bitmaps",
-						Opt_removed),
-	fsparam_flag	("no_prefetch_block_bitmaps",
+	fsparam_u32("max_dir_size_kb",		Opt_max_dir_size_kb),
+	fsparam_flag("test_dummy_encryption",	Opt_test_dummy_encryption),
+	fsparam_string("test_dummy_encryption",	Opt_test_dummy_encryption),
+	fsparam_flag("inlinecrypt",		Opt_inlinecrypt),
+	fsparam_flag("nombcache",		Opt_nombcache),
+	fsparam_flag("no_mbcache",		Opt_nombcache),	/* for backward compatibility */
+	fsparam_flag("prefetch_block_bitmaps",	Opt_removed),
+	fsparam_flag("no_prefetch_block_bitmaps",
 						Opt_no_prefetch_block_bitmaps),
-	fsparam_s32	("mb_optimize_scan",	Opt_mb_optimize_scan),
-	fsparam_string	("check",		Opt_removed),	/* mount option from ext2/3 */
-	fsparam_flag	("nocheck",		Opt_removed),	/* mount option from ext2/3 */
-	fsparam_flag	("reservation",		Opt_removed),	/* mount option from ext2/3 */
-	fsparam_flag	("noreservation",	Opt_removed),	/* mount option from ext2/3 */
-	fsparam_u32	("journal",		Opt_removed),	/* mount option from ext2/3 */
+	fsparam_s32("mb_optimize_scan",		Opt_mb_optimize_scan),
+	fsparam_string("check",			Opt_removed),	/* mount option from ext2/3 */
+	fsparam_flag("nocheck",			Opt_removed),	/* mount option from ext2/3 */
+	fsparam_flag("reservation",		Opt_removed),	/* mount option from ext2/3 */
+	fsparam_flag("noreservation",		Opt_removed),	/* mount option from ext2/3 */
+	fsparam_u32("journal",			Opt_removed),	/* mount option from ext2/3 */
 	{}
 };
 